<?php
// setup.php for diaRice - photo calendar 0.5 en/de 22:19 15.01.2009
// Copyright (c) 2007-2009 Michael Daum,  visit http://webdaum.de/

@session_start();
if(!defined('_PATH')) {
	define('_PATH',realpath('../'));
}

// Security:
include_once (_PATH.'/classes/login.inc.php');
$guard = new check();
if($this->c_config && !$guard->check_user()) {
	if(!isset($_POST['version'])) {
	
		$errorpage =$this->c_host.$this->c_phpself.'files/error_401.php';

		Header('HTTP/1.1 401 Unauthorized');
		Header("location:$errorpage");
		exit;
	}
}

header('Cache-Control: no-store, no-cache, must-revalidate'); // HTTP/1.1
header('Cache-Control: post-check=0, pre-check=0', false);
header('Pragma: no-cache'); // HTTP/1.0
	
include ('lang/lang_options.php');

$out = '';
if(!isset($_GET['step'])) {
	$_GET['step'] = '1';
}

if(isset($_GET['lang'])) {
	$out.= '<input type="hidden" name="lang" value="'.$_GET['lang']."\" />\n";
	$_SESSION['lang'] = $_GET['lang'];
	$this->c_lang = $_GET['lang'];
} else if(isset($_SESSION['auth'])) {
	$_GET['lang'] = $this->c_lang ;
}


$steps = array(
	'1'=>'intro',
	'2'=>'check',
	'3'=>'account',
	'4'=>'profile',
	'5'=>'config',
	'6'=>'feedback',
	'7'=>'feedback'
);

$re_dirs = array(
	'data',
	'data/templates',
	'data/modules',
	'data/logs',
	'data/logs/user',
	'data/comment',
	'data/user',
	'data/user/admin',
	'data/images'
);
foreach ($lang_option as $k => $v) {
	$re_dirs[] = "data/images/$k";
}

$submit = 'submit';
$method = 'get';
$emailadress = $this->c_support_email;

switch ($_GET['step']) {

	case '1':
		if(!isset($_GET['lang'])) {
			$_GET['lang'] = $this->c_main_lang;
		}
  	$out.= '<p><strong>'.CHOOSE_LANG.': </strong>';
  	$out.= "<select size=\"1\" name=\"lang\" onchange=\"this.form.step.value=1;this.form.submit()\">\n";
    $lang_option = array_unique($lang_option);
    foreach ($lang_option as $k => $v) {
    	$k=$k==$_GET['lang']?"$k\" selected=\"selected":$k;
    	$out.= "<option value=\"$k\">$v</option>\n";
    }	
  	$out.= "</select><br />\n(".TIP_LANG.")</p>\n";
  	$out.= '<h3>'.HEADER_INTRO."</h3>\n";
  	$out.= '<p>'.TEXT_INTRO."</p>\n";
		break;
		
	case '2':
		$check = $this->file_mngr;
		if(!$check->check_dirs($re_dirs)) {
			$msg = $check->create_dirs($re_dirs);
			if($msg == '') {
				$out.='<h3>'.MSG_DIRS_CREATE."</h3>\n";
			} else {
				$out= '<div class="msg">'.ERROR." $msg</div>\n";
				$submit = 'disabled';
			}
		} else {
			$out.='<h3>'.MSG_DIRS_EXIST."</h3>\n";
		}
		$out.="<ul>\n";
		foreach ($re_dirs as $dir) {
  			$out.= "<li>$dir</li>\n";
  		}	
		$out.="</ul>\n";
		break;
		
	case '3':
		$check = $this->file_mngr;
		if(!$check->check_dirs($re_dirs)) {
			header('location:'.$this->c_host.$this->c_phpself.$this->c_filename."?go=setup&step=2&lang=$_GET[lang]");
			exit;
		}
		$test = new login();
		if(!$test->load_data() || $test->key('admin')=== false ) {
  		$password = substr(md5(crypt('admin')),0,8);
  		$login = new login('admin',$password,0);
  		$login_data[0] = new login('admin',$password,0);
  		$login->data[0] = &$login_data[0];
  		if($login_data[0]->to_database()) {
  			$out.= '<h3>'.MSG_ADMIN_CREATED."</h3>\n";
  		} else {
				$out= '<div class="msg">'.ERROR.' '.ERROR_ADMIN."</div>\n";
				$submit = 'disabled';		
  		}
		} else {
  		$out.= '<h3>'.MSG_ADMIN_SET."</h3>\n";	
			$password = $test->data[$test->key('admin')]->userpass;
			$hide_tip = 1;
		}
  	$out.= '<em>'.DFN_USERNAME.":</em> <strong>admin</strong><br />\n";
  	$out.= '<em>'.DFN_USERPASSWORD.":</em> <strong>$password</strong><br />\n";
  	if(!$hide_tip) {
			$out.='<p>'.TIP_ACCOUNT."</p>\n";
		}
		break;
		
	case '4':
		$test = new login();
		if(!$test->load_data() || $test->key('admin')=== false) {
			header('location:'.$this->c_host.$this->c_phpself.$this->c_filename."?go=setup&step=3&lang=$_GET[lang]");
			exit;
		}
		$method = 'post';
		$test = new profile();
		if(!$test->load_data() || !isset($test->data['admin'])) {
			$profile = new profile('admin');
			$profile_data['admin']= new profile('admin');
			$profile->data['admin'] = $profile_data['admin'];
			if($profile->data['admin']->to_database()) {
				$out.= '<h3>'.MSG_PROFILE_CREATED."!</h3>\n";
				$out.='<p>'.LEGEND_ENTER_PROFILE.":</p>\n";
			} else {
				$out= '<div class="msg">'.ERROR.' '.ERROR_PROFILE."</div>\n";
				$submit = 'disabled';  		
			}
		} else {
			$out.= '<h3>'.MSG_PROFILE_SET."</h3>\n";	
			$hide_tip = 1;
			$profile = new profile();
		}		
		$profile->load_data();
		$out.=
'<br class="clear" />
<dfn>'.DFN_FIRST_NAME.':</dfn>
<input type="text" name="first_name" value="'.$profile->data['admin']->first_name.'" /><br />
<dfn>'.DFN_LAST_NAME.':</dfn>
<input type="text" name="last_name" value="'.$profile->data['admin']->last_name.'" /><br />
<dfn>'.DFN_RESIDENCE.':</dfn>
<input type="text" name="residence" value="'.$profile->data['admin']->residence.'" /><br />
<dfn>'.DFN_EMAIL.':</dfn>
<input type="text" name="email" value="'.$profile->data['admin']->email.'" /><br />
<dfn>'.DFN_WEBSITE.': <b>http://</b></dfn>
<input type="text" name="website" value="'.$profile->data['admin']->website.'" /><br />
<input type="hidden" name="media" value="'.$profile->data['admin']->media.'" />
<input type="hidden" name="text" value="'.htmlentities(stripcslashes(str_replace("","\n",$profile->data['admin']->text))).'" />
<input type="hidden" name="language" value="'.$profile->data['admin']->language.'" />
<input type="hidden" name="skin" value="'.$profile->data['admin']->skin.'" />';

		if(!$hide_tip) {
			$out.='<p>'.TIP_PROFILE."</p>\n";
		}
		break;	
		
	case '5':
		$method = 'post';
		$profile = new profile();
		if(!$profile->load_data()) {
			header('location:'.$this->c_host.$this->c_phpself.$this->c_filename."?go=setup&step=4&lang=$_GET[lang]");
			exit;
		}
		$out.= '<h3>'.ADMIN_CONFIG."</h3>\n";
		if(isset($_POST['first_name'])) {
  		$profile = new profile('admin');
  		$profile_data['admin']= new profile(
				'admin',
				$_POST['first_name'],
				$_POST['last_name'],
				$_POST['email'],
				$_POST['residence'],
				$_POST['website'],
				'admin',
				$_POST['media'],
				$_POST['text'],
				$_POST['language'],
				$_POST['skin']				
			);
  		$profile->data['admin'] = $profile_data['admin'];
  		if($profile->data['admin']->to_database()) {
    		$out.= '<p>'.MENU_PROFILE.': '.MSG_SAVED."!</p>\n";
    		$out.= '<p><b>'.DFN_TIP.': </b>'.MSG_REUSE_PROFILE."!</p>\n";
  		} else {
				$out= '<div class="msg">'.ERROR.' '.ERROR_PROFILE."</div>\n";
				$submit = 'disabled';  		
  		}
  	}
  	if($this->c_config) {
  		include($this->c_config);
  	} else {
  		$owners_name = $profile->data['admin']->fullname;
  		$owners_residence = $profile->data['admin']->residence;
  		$owners_email = $profile->data['admin']->email;
  		$website = $profile->data['admin']->website;
  		$image_path = $this->c_image_path;
  		$year = $this->c_first_year;
  		$month = $this->c_first_month;
  		$day = $this->c_first_day;
  	}
  	$out.='<p>'.TIP_CONFIG_PATH.".<br/>\n".TIP_CONFIG_START.".</p>\n".
'<br class="clear" />
<dfn>'.DFN_OWNERS_NAME.':</dfn>
<input type="text" name="owners_name" value="'.$owners_name.'" /><br />
<dfn>'.DFN_RESIDENCE.':</dfn>
<textarea name="owners_residence">'.htmlentities($owners_residence).'</textarea>
<dfn>'.DFN_EMAIL.':</dfn>
<input type="text" name="owners_email" value="'.$owners_email.'" /><br />
<dfn>'.DFN_WEBSITE.': <b>http://</b></dfn>
<input type="text" name="website" value="'.$website.'" /><br />
<dfn>'.DFN_PATH_TO.' '.DFN_IMAGES.' '.DFN_FOLDER.':</dfn>
<input type="text" name="image_path" value="'.$image_path.'" /><br />
<dfn>'.FIRST.' '.TIME_YEAR.'</dfn>
<input type="text" name="year" value="'.$year.'" /><br />
<dfn>'.FIRST.' '.TIME_MONTH.'</dfn>
<input type="text" name="month" value="'.$month.'" /><br />
<dfn>'.FIRST.' '.TIME_DAY.'</dfn>
<input type="text" name="day" value="'.$day.'" /><br class=\"clear\" />
';
		break;
		
	case '6':
		if(!isset($_POST['owners_name'])) {
			header('location:'.$this->c_host.$this->c_phpself.$this->c_filename."?go=setup&step=5&lang=$_GET[lang]");
			exit;
		}
		$method = 'post';
  	$config_data=_PATH.'/data/config_data.php';
    $config="<?php\n\n";
    
    // RESET: use default values for some of the following:
    $_POST['online'] = '0';
    $_POST['alternate_lang'] = implode(',',array_keys($lang_option));
    $_POST['template'] = $this->c_template;
    $_POST['css'] = $this->c_style;
    $_POST['meta_keywords'] = $this->c_meta_keywords;
    $_POST['meta_description'] = $this->c_meta_description;
	$_POST['first_wday'] = '0';
	$_POST['calender_never_ends'] = '0';
	$_POST['hour_offset'] = '0';
    $_POST['sep'] = $this->c_sep;
    $_POST['direction'] = $this->c_direction;
    $_POST['speed'] = $this->c_autoplay_speed;
    $_POST['effects'] = $this->c_effects;
    $_POST['thumb_size'] = $this->c_thumb_size;
    $_POST['log_history_visitor'] = 'off';
    $_POST['log_history_user'] = 'off';
    $_POST['log_history_bots'] = 'off';
    $_POST['use_mod_rewrite'] = 'off';
    $_POST['send_xml_declaration'] = 'on';
    $_POST['max_period'] = $this->c_max_period;
    $_POST['use_ext_image_description'] = 'on';
    $_POST['use_ext_comments'] = 'off';
    $_POST['use_ext_extlink'] = 'off';
    $_POST['use_ext_people'] = 'off';
    $_POST['link_to_editorial'] = '';
    $_POST['link_to_privacy'] = ''; 
    
    foreach ($_POST as $key=>$element) {
      if ($key=='Submit' || $key=='go' || $key=='step') {
  	    continue;
  	  } else {
  	  	if(is_array($element)) {
  	  		$element = implode(',',$element);
  	  	}
  			$config .="\$$key = '".$element."';\n\n";
  		}
    } 
    $config.='?';
    $config.='>';
    if(file_put_contents($config_data,$config)) {
			$out.= '<h3>'.MSG_CONFIG_CREATE."</h3>\n";
			
			$this->c_main_lang = $_POST['lang'];
			
			if($_POST['image_path'] !=='' && !is_dir($_POST['image_path']) && @!mkdir($_POST['image_path'])) {
				$out.= '<div class="msg"><strong>'.WARNING.' '.DFN_PATH_TO.' '.DFN_IMAGES.' '.DFN_FOLDER.":</strong>\n".
				'<p>'.ERROR_DIR_PATH."<br />\n".MSG_IGNORE."</p></div>\n"; 
			} else if(!$guard->check_user()) {
  			$out.='<p>'.MSG_INSTALL."</p>\n";
  			$out.='<p>'.TIP_GET_STARTED."</p>\n";
  		} else {
  			// create offline image's directory:
  			$dir =_PATH.'/'.$_POST['image_path'].'offline';
  			if(!is_dir($dir)) {
					mkdir($dir);
				}
  			$out.='<p>'.MSG_INSTALL."</p>\n"; 		
  		}
  		
  		$out.='<p>'.TEXT_FEEDBACK."</p>\n"; 
  		$out.='<br class="clear" />
<fieldset>
<legend>Feedback</legend>
<div id="eintrag">
<dfn>'.DFN_WEBSITE.': <b>http://</b></dfn>
<input type="text" name="website" value="'.$_POST['website'].'" /><br />'.'
<dfn>Version:</dfn>
<input type="text" name="version" value="'.$this->c_version().'" /><br />
<textarea cols="80" rows="20" name="text">
</textarea>
<input type="'.$submit.'" class="button" value="'.FORM_SUBMIT.'&raquo;" />
</div>
</fieldset>';
  		
		} else {
				$out= '<div class="msg">'.ERROR." ".ERROR_FAIL_SAVE."</div>\n";
				$submit = 'disabled';  		
		}
		break;
		
	// send the feedback, congratulate new user	
	case '7': 
		if(isset($_POST['website'])) {
			if($mail = mail(
			$emailadress,
			'Neue '.$_POST['version'].' Webseite: '.$_POST['website'],
			$form->field['text']."\n\n".
			$_POST['website'],
			'From: webmaster@'.$_POST['website'])) {

				$out.= '<h3>'.THANKS."</h3>\n";
				$out.= '<p>'.TIP_GET_STARTED."</p>\n";
				$out.= '<p>'.THANKS_AGAIN."</p>\n";
			}
		}
		break;
}
echo "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?"."><!-- IE Quirks, please! -->"."\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title><?php echo $this->c_calendar_name .' | Setup';?></title>
<meta http-equiv="Content-Type" content=
"text/html; charset=iso-8859-1" />
<link rel="stylesheet" type="text/css" href="css/admin/black.css" />
<link rel="stylesheet" type="text/css" href="css/admin/index.css" />
</head>
<body id="setup" class="<?php echo $steps[$_GET['step']];?>">
<div id="container">
<div id="kopf">
<h1><?php echo "$this->c_calendar_name | Setup";?>
 | <small><?echo date(TIME_FORMAT,C_TODAYS_DATE);?></small>
</h1>
<div id="navi">
<?php

if(isset($_SESSION['auth'])) {
 include ('menu.php');
}
 
?>
</div>
</div>
<?php

	$next = (int) $_GET['step']+1;
	$back = (int) $_GET['step']-1;
	
echo "<form method=\"$method\" action=\"?go=setup&amp;step=$next&amp;lang=$_GET[lang]\">
<div id=\"sidebar\">
<ol>
<li id=\"intro\">".INTRODUCTION."</li>
<li id=\"check\">".CHECK_INSTALL."</li>
<li id=\"account\">".CREATE_ACCOUNT."</li>
<li id=\"profile\">".CREATE_PROFILE."</li>
<li id=\"config\">".CREATE_CONFIG."</li>
<li id=\"feedback\">".CREATE_FEEDBACK."</li>
</ol>
</div>
<div id=\"wrapper\">
<div id=\"content\">
$out".'
<input type="hidden" name="step" value="'.$next.'" />
<input type="hidden" name="go" value="setup" />
</div>
</div>
<div class="clear" id="befehlskonsole">
<a href="./" class="button">'.MODE_CANCEL.'</a>';
if($next<=6 || $submit=='disabled') {
	echo '<input type="'.$submit.'" class="'.$submit.'" value="'.NEXT.'&raquo;" />';
} else {
	echo "<a href=\"?go=login&amp;lang=$_GET[lang]\" class=\"submit\">Login&raquo;</a>";
}
if($back>0 && $back<5) {
	echo "<a href=\"?go=setup&amp;step=$back&amp;lang=$_GET[lang]\" class=\"button\">&laquo;".BACK.'</a>';
}
echo '
</div>
</form>
</div>
</body>
</html>';
?>